####7.2 O modelo mais simples possivel
#Vamos retomar a regressao da massa do cerebro em funcao da massa corporal de alguns animais, do tutorial ajuste e diagnostico de uma regressao:
library(MASS)
data(Animals)

anim.m2 <- lm(log(brain)~log(body),data=Animals, subset=!(log(Animals$body)>8&log(Animals$brain)<6))

#Agora ajuste este modelo:
anim.m0 <- lm(log(brain)~1, data=Animals, subset=!(log(Animals$body)>8&log(Animals$brain)<6))

#E compare os dois:
anova(anim.m0,anim.m2)


##Perguntas
#1. Qual a relacao do comando 'anova' acima com:
anova(anim.m2)
##RESP: A funcao 'anova', quando aplicada a apenas um modelo, apresenta a quantidade de variancia (Sum Sq) da 
#variavel resposta (log(brain)) que foi explicada pela variavel preditora do modelo (log(body)) e a quantidade
#de variancia ainda nao explicada (Residuals). Por outro lado, quando aplicada a dois modelos, a funcao anova reporta o residuo
#dos modelos (RSS), ou seja, a quantidade de variacao que nao explicada pelas preditoras de cada modelo.

#2. Qual a relacao entre os valores obtidos por estes comandos:
summary(anim.m0)
mean(log(Animals$brain[!(log(Animals$body)>8&log(Animals$brain)<6)]))
sd(log(Animals$brain[!(log(Animals$body)>8&log(Animals$brain)<6)]))
#RESP: A funcao summary, quando utilizada em apenas um modelo (e.g. "lm"), mostra as principais informacoes deste modelo, tais
#como as estimativas dos parametros ('coefficients') e o desvio padrao da distribuicao dos residuos (reportado pela summary como 
#Residual standard error). Como o modelo em questao (i.e., anim.m0) estima a relacao da variavel resposta em funcao de uma constante
#(y ~ 1; sem preditora), a media dessa variavel resposta e igual ao intercepto estimado por este modelo, assim como o desvio padrao 
#dessa variavel e igual ao desvio padrao da distribuicao dos residuos.
