#Exerccio 5_1 Editando alguns parmetros grficos

#Leia os dados Conjunto de Dados: Biomassa de rvores de Eucalyptus saligna em um objeto chamado saligna

saligna <- read.csv("esaligna.csv", sep = ",") #lendo o bd
saligna

str(saligna) #estrutura

png(filename = "salina.png") #salvamento em .png

plot(saligna$ht ~ saligna$dap, #altura (Y) em funo do DAP (X)
     cex = 1.4, #deixando simbolo em 40%
     pch = 19, #preenchimento slido
     col = 'red', #cor vermelha
     xlab = "Dimetro  altura do peito (cm)", #legenda eixo X
     ylab = "Altura (m)", #legenda eixo y
     cex.lab = 1.7, #tamanho da legenda do eixo
     cex.axis = 1.4, #tamanho da fonte do eixo
     tcl = 0.3, #ticks marks para dentro, tamanho 0.3
     las = 1, #valores do eixo Y na horizontal
     bty = "l", # formato "L" das bordas do grfico
     main = "Eucalypthus saligna", #ttulo
     cex.main = 1.8 #tamanho do titulo
    )

dev.off() #finalizando o salvamento

#5.2 Dois grficos juntos

par(mfrow=c(1,2)) #criando janela para dois grficos

par(bty = "l") # formato "L" das bordas do grfico; para box plot  necessrio deixar no comando par

#grfico 1 
boxplot (saligna$dap ~ saligna$talhao,
         col = 'red', #cor vermelha
         xlab = "Talho", #legenda eixo X
         ylab = "DAP", #legenda eixo y
         cex.lab = 1.1, #tamanho da legenda do eixo
         cex.axis = 1.1, #tamanho da fonte do eixo
         las = 1, #valores do eixo Y na horizontal
         main = "Boxplot", #ttulo
         cex.main = 1.6, #tamanho do titulo
         xaxt = "n") #valores do eixo x

axis(side = 1, #eixo na posio inferior
     at = c(1, 2, 3, 4, 5, 6), #valores que sero substituidos
     labels = texto_talhao, #labels a serem substituidos
     las =2) # posio na vertical do eixo

texto_talhao <- paste("", "Talho \n", c(16, 17, 18, 22, 23, 32)) #criando labels para o eixo x


text(x = 0.7, y = 22,"a", col = 'red') # colocando legenda "a"

#grfico 2 - O segundo deve ter apenas a mdia e uma barra de desvio-padro do dap, para cada talho.

str(saligna) #verificando a estrutura

saligna$talhao <- factor(saligna$talhao) #transformando a var talhao em fator!

t_medias <- aggregate(saligna$dap, 
                      by = list(saligna$talhao), 
                      FUN = mean) #calculando as mdias dos dap para cada talhao
t_medias

colnames(t_medias) <- c("talhao", "media") #renomeando as colunas
t_medias

t_dp <- aggregate(saligna$dap, 
                  by = list(saligna$talhao), 
                  FUN = sd) #calculando os devios dos dap para cada talhao


colnames(t_dp) <- c("talhao", "desvio") #renomeando as colunas

talhao_dap <- data.frame(c(t_medias[2], t_dp[2])) #juntando em data.frame

talhao_dap$media_menos_dp <- talhao_dap[1] - talhao_dap[2] #media menos o dp

talhao_dap$media_mais_dp <- talhao_dap[2]  + talhao_dap[1] #media mais o dp


talhao_dap <- as.matrix(talhao_dap) #transformando em matrix

row.names(talhao_dap) <- paste("talhao", c(16, 17, 18, 22, 23, 32), sep = "_") #alterando o nome das linhas


plot(talhao_dap[, 1] ~ c(1:6), #colocando as variaveis 
     xlim = c(1, 6), #limites do eixo x
     ylim = c(1, 22), #limites do eixo y
     xaxt = "n", #tirando os valores do eixo x
     xlab = "Talho", #leganda do eixo x 
     ylab = "DAP", # legenda do eixo y
     bty = "l", # formato "L" das bordas do grfico
     col = 'red',
     cex = 1.4, #deixando simbolo em 40%
     pch = 19, #preenchimento slido
     cex.lab = 1.1, #tamanho da legenda do eixo
     cex.axis = 1.1, #tamanho da fonte do eixo
     las = 1, #valores do eixo Y na horizontal
     main = "Mdia - Desvio Padro", #ttulo
     cex.main = 1.6) #tamanho do titulo)


segments(x0 = 1:6, #numero de seguimentos
         y0 = as.numeric(talhao_dap[, 3]), #variavel da media menos o dp
         x1 = 1:6, #numero de seguimentos
         y1 = as.numeric(talhao_dap[, 4]),#variavel da media mais o dp
         col = 'red') #cor vermelha

axis(side = 1, #eixo na posio inferior
     at = c(1, 2, 3, 4, 5, 6), #valores que sero substituidos
     labels = texto_talhao, #labels a serem substituidos
     las =2) # posio na vertical do eixo

text(x = 1.3, y = 22,"b", col = 'red')# colocando a legenda da letra "b"

#5.3 Adivinhando o cdigo

exerc3 <- read.csv("exercicio3.csv") #lendo o bd

str(exerc3) # estrutura

exerc3$y2 <- as.factor(exerc3$y2) #trabsformando y2 em factor


par(mfrow=c(1,2)) #criando janela para dois grficos
par(mar = c(3,2,3,1), #ajustando as margens
    par(tcl = 0.3)) #linha dos itens do eixo para dentro

plot(exerc3$x1, exerc3$y1, #variaveis plotadas
     ylim = c(0, 3), #limite do eixo y 
     xlim = c(0.5, 2), #limite do eixo X
     xlab = "Log(Patch size) (ha)", #legenda eixo X
     ylab = "Euclidean distances", #legenda eixo y
     pch = 17, #simbolo de triangulo
     bty = "l", # formato "L" das bordas do grfico
     )

model <- lm(exerc3$x1 ~ exerc3$y1) #modelo linear

abline(model) #linha do modelo

#locator(1) #localizar coordenadas

text(x = 2, y = 3, "a") #colocando o texto "a"

par(bty = "l") # formato "L" das bordas do grfico; para box plot  necessrio deixar no comando par

boxplot(exerc3$x2 ~ exerc3$y2, #variaveis
        xlab = "", #legenda eixo x
        ylab = "", #legenda eixo y
        xaxt = "n") #valores do eixo x

axis(side = 1, #eixo na posio inferior
     at = c(1, 2, 3, 4, 5, 6), #valores que sero substituidos
     labels = c("Small","medium \n Edge","Medium \n Interior", "Large  \n Edge", "Large \n Interior", "Control")) #labels a serem substituidos

#locator(1) #localizar coordenadas

text(x = 6, y = 2.7, "b")  #colocando o texto "b"

text(x = 1.01, y = 2.9, "*")  #colocando o texto "*"
text(x = 1.994659, y = 2.9, "*")  #colocando o texto "*"
text(x = 2.952696, y = 2.9, "*")  #colocando o texto "*"
text(x = 3.12, y = 2.9, "*")  #colocando o texto "*"
text(x = 4.01, y = 2.9, "*")  #colocando o texto "*"
text(x = 4.62, y = 2.9, "*")  #colocando o texto "*"
text(x = 4.75, y = 2.9, "*")  #colocando o texto "*"
text(x = 4.85, y = 2.9, "*")  #colocando o texto "*"

