#Patrcia Coutinho Mller
#Exerccios 4 - Anlises Exploratrias


#4.2 Cervejas

#Uma amostra de 30 estudantes foi indagada sobre seu tipo de cerveja preferida, com o seguinte resultado

#cervejas <-c("chope","lata","garrafa","chope","garrafa", "garrafa","lata","lata","nenhuma","lata","garrafa","garrafa", "garrafa","lata","lata","lata","garrafa","lata","chope","nenhuma", "garrafa","garrafa","garrafa","chope","garrafa","garrafa","chope","garrafa","lata","lata")

#1-Represente este resultado como um grfico de barras e um dotplot (funo dotchart).

cervejas <-c("chope","lata","garrafa","chope","garrafa", "garrafa","lata","lata","nenhuma","lata","garrafa","garrafa", "garrafa","lata","lata","lata","garrafa","lata","chope","nenhuma", "garrafa","garrafa","garrafa","chope","garrafa","garrafa","chope","garrafa","lata","lata")
cerv<- table(cervejas)
cerv
cvj<- barplot(cerv)

cv2<-dotchart(cerv)

#2-Qual tem maior razo dado/tinta?

#O dotchart tem maior razo dado/tinta, pois consegue representar 30 dados com somente 4 pontos, enquanto o barplot precisa de 4 barras pra represent-los. 

#4.3 Caixetais

#Neste exerccio, use o objeto caixeta, criado no tutorial Explorao de uma Varivel Categrica.
#Construa um histograma do dap1) dos fustes dos caixetais.
getwd()
setwd("C:/Users/Paty/Desktop/R")
caixeta<- read.csv("dadoscaixeta.csv", as.is= T)

help("hist")
class (caixeta)

#Cap=2*pi*r
#Cap=pi*dap
#dap=Cap/pi

dap<-(caixeta$cap)/pi
hist(dap)

#Construa histogramas da altura das rvores para os diferentes caixetais ('local').
hist(caixeta$h[caixeta$local == "chauas"], xlim=range(0:300), ylim=range(0:250))
hist(caixeta$h[caixeta$local == "jureia"], xlim=range(0:300), ylim=range(0:250))
hist(caixeta$h[caixeta$local == "retiro"], xlim=range(0:300), ylim=range(0:250))


#H diferenas entre as estruturas (distribuio de tamanhos) dos caixetais?
#As estruturas dos caixetais possuem diferenas, pois os tamanhos das rvores em chauas se concentra principalmente entre 0 150 cm, em jureia se concentra  se concentram principalmente entre 50 e 150cm e em retiro, entre 0 e 150cm.


#4.4 - Eucaliptos

#Neste exerccio, use o conjunto de dados Inventrio em Florestas Plantadas de Eucalyptus grandis.
#Utilize o grfico boxplot para analisar o DAP de rvores de E. grandis em funo das variveis regio (regiao) e rotao (rotacao).

e.grandis<-read.csv("egrandis.csv", header=T, sep = ";")
head(e.grandis)

boxplot(dap~regiao*rotacao, data=e.grandis, xlab = "Regiao e rotacao", ylab="DAP (cm)")
boxplot(dap~regiao, data=e.grandis,xlab = "Regiao", ylab="DAP (cm)")
boxplot(dap~rotacao, data=e.grandis,xlab = "Rotacao", ylab="DAP (cm)")

#Nas regio Bofete e Salto, os mximos valores do DAP variam bastante (principalmente devido aos outliers na regio Bofete) e os mnimos e medianas no variam muito. Em relao a rotao, os valores de DAP da rotao 1 so maiores que a rotao 2 e possuem muitos outliers.

#Avalie a normalidade da altura do conjunto total de rvores com um grfico quantil-quantil contra a distribuio normal.
qqnorm(e.grandis$h)
qqline(e.grandis$h, col="red")

#No grfico  possvel observar que os valores de altura nas extremidades se distanciam bastante dos valores da linha de normalidade, ou seja, uma parte dos dados no segue uma distribuio normal.  

#4.5 - Mais caixetais
#Aqui usaremos novamente o objeto caixeta, criado no tutorial Explorao de uma Varivel Categrica.
#Analise a relao dap-altura ('dap' e 'h') em funo do caixetal (local) com a funo plot, mas somente para as rvores 2) de caixeta (Tabebuia cassinoides).
caixeta
T.cassi <- caixeta[caixeta$especie=="Tabebuia cassinoides",]
T.cassi

T.cassi$area.basal <- pi*((T.cassi$cap*2)^2)

soma.area <- aggregate(T.cassi$area.basal,by=list(T.cassi$local,T.cassi$arvore,T.cassi$h), sum)

###Nomear colunas
colnames(soma.area) <- c("Local","Arvore","Altura","Area")
soma.area

###DAP total de cada arvore.
soma.area$dap.total <- 2*sqrt(soma.area$Area/pi)
soma.area$dap.total

###Criando o grfico da relao dap e altura em funo do local.
par(mfrow=c(1,3))

plot(soma.area$dap.total~Altura, data=soma.area, subset=Local=="chauas", main="Chauas")

plot(soma.area$dap.total~Altura, data=soma.area, subset=Local=="jureia",  main="Jureia")

plot(soma.area$dap.total~Altura, data=soma.area, subset=Local=="retiro",main="Retiro")


##2.Para a mesma relacao do item anterior, verifique linearidade com a funcao scatter.smooth
###Criando o grafico de scatter smooth da relacao dap e altura em funcao do local. 

par(mfrow=c(1,3))

scatter.smooth(soma.area$Altura[soma.area$Local=="chauas"],soma.area$dap.total[soma.area$Local=="chauas"],main="Chauas",xlab="Altura",yla="DAP",col="red")

scatter.smooth(soma.area$Altura[soma.area$Local=="retiro"],soma.area$dap.total[soma.area$Local=="retiro"],main="Jureia",xlab="Altura",yla="DAP",col="red")

scatter.smooth(soma.area$Altura[soma.area$Local=="jureia"],soma.area$dap.total[soma.area$Local=="jureia"], main="Retiro",xlab="Altura",yla="DAP",col="red")


#Utilizando o pacote lattice, analise a relao dap-altura ('dap' e 'h') em funo do caixetal (local), mas somente para as rvores 3) de caixeta (Tabebuia cassinoides).
library(lattice)
xyplot(soma.area.dap.total~Altura|Local, data=soma.area)
