

############# Uma estimativa da incerteza na previso do modelo ###############################

# Construa esse grfico para avaliar a incerteza do modelo para a relao peso do beb
# (kg) ~ tempo de gestao (dias) dos dados Massa ao Nascer e Dados da me, usando a 
# frmula acima para estimar o intervalo de confiana de 95%

dado <- read.table("babies.txt", header= TRUE, as.is = TRUE)
head(dado)
nrow(dado)

dado$bwt[dado$bwt==999] <- NA
dado$gestation[dado$gestation==999] <- NA

dado <- na.omit(dado)

# dado$parity[dado$parity==9] <- NA
# dado$age[dado$age==99] <- NA
# dado$height[dado$height==99] <- NA
# dado$weight[dado$weight==999] <- NA
# dado$smoke[dado$smoke==9] <- NA

# checando

nrow(dado)
length(dado$bwt)
length(dado$gestation)

dado.lm <- lm(bwt~gestation,data=dado)
summary(dado.lm)

# "novo" eixo x

newx <- seq(min(dado$gestation) -10, max(dado$gestation) + 10, length.out=100)

# Erro padrao pela formula

var.y <- var(dado$bwt)

am <- 1/length(dado$gestation)

med.ssx <- ((newx-mean(dado$gestation))^2)/(sum((dado$gestation-mean(dado$gestation))^2))

se2 <- sqrt(var.y*(am+med.ssx))

#Calculo do valor de t para 95% e n-2gl

t.val <- qt(0.025, length(dado$gestation)-2, lower.tail = F) 

# intervalo de confianca

ic <- t.val*se2 

y.pred <- predict(dado.lm, newdata= data.frame(gestation=newx),interval = 'confidence')

# grafico com o intervalo de confianca de 95% dos preditos

plot(bwt~gestation, data=dado, cex=0.6, col="green", bty="l", pch=16,
     ylab="Peso do beb (Kg)", xlab="Tempo de gestao (dias)")

abline(dado.lm, col="red",lty=3)

polygon(c(rev(newx), newx), c(rev(y.pred[,2]), y.pred[,3]), col=rgb(0,0,0, 0.2))




################ Galileu estava Certo? #########################################
 

# Partindo do tutorial Ajuste de Polinmios, avalie se um polinmio de terceiro grau  um melhor
# modelo para descrever os dados do experimento de Galileu. A equao para este modelo :


# As alturas de lanamentos e as distncias percorridas obtidas por Galileu sao:

init.h = c(600, 700, 800, 950, 1100, 1300, 1500)
h.d = c(253, 337, 395, 451, 495, 534, 573)

# Vamos fazer o grfico de disperso:

plot(h.d~init.h)

# podemos ajustar os dois modelos e usar o comando anova para testar se o acrscimo do termo 
# quadrtico implicou em melhora. O ajuste da reta  feito do modo usual:

mod1 <- lm(h.d~init.h)
anova(mod1)

# Mas para ajustar a parbola corretamente usamos a funo I() (de insulate), necessria para
# isolar a operao matemtica de elevar ao quadrado

# O comando para ajustar a equao da parbola :

mod2 <- update(mod1,.~. +I(init.h^2))
# E agora podemos comparar os dois modelos:

anova(mod1,mod2)

# O modelo de parbola  claramente superior, o que fica evidente se acrescentamos as linhas
# dos previstos pelos dois modelos ao grfico:

abline(mod1)
cf.m2 <- coef(mod2)
curve(cf.m2[1]+cf.m2[2]*x+cf.m2[3]*x^2, add=T, lty=2)

# Por fim, verifique o resumo do modelo selecionado:

summary(mod2)

### RESPOSTA: ############

# Modelo 3

mod3 <- update(mod1,.~. +I(init.h^2)+ I(init.h^3))

# E agora podemos comparar os modelos:

anova(mod1,mod2,mod3)

abline(mod1)
cf.m3 <- coef(mod3)
curve(cf.m3[1]+cf.m3[2]*x+cf.m3[3]*x^2+cf.m3[4]*x^3, add=T, lty=2,col="red")

	### Resp.: Galileu estava certo. Quando olhamos os valores de anova(mod1,mod2,mod3)
	# conseguimos notar que o modelo com melhor poder de explicacao continua sento o modelo 2
	# e olhando a curva produzida pelo modelo do polinomio de grau 3 notamos que ela adquire
	# uma forma diferenciada no final, que nao mais uma parabola.

