
############## 5.1 Editando alguns parmetros grficos #################

# Leia os dados Conjunto de Dados: Biomassa de rvores de Eucalyptus saligna em um
# objeto chamado saligna

saligna <- read.table("esaligna.csv", sep=",",h=T)

# Use o simbolo de crculo preenchido aumentado em 40%, na cor vermelha - 
# Legendas dos eixos com nomes das variveis e suas unidades da seguinte forma:

# x: Dimetro  altura do peito (cm)

# y: Altura (m)

# Tamanho das fontes e legendas dos eixos com 50% e 70% de aumento que o padro, 
# respectivamente

# Marcaes da escala dos eixos (ticks marks) para dentro da rea do grfico com tamanho
# de 0.3 do tamanho da linha.

# Valores do eixo y na horizontal

# Apenas as linhas referentes/ aos eixos x e y (formato L)

# Ttulo contendo: *Eucalypthus saligna* com aumento de 80%

# Salve o grfico no formato png no arquivo saligna.png no diretrio de trabalho atual.

saligna <- read.table("esaligna.csv", sep=",",h=T) # de novo

par(tcl=0.3,las=1,mar=c(5.1,4.5,4.,2.1),bty="l")

plot(saligna$dap,saligna$ht,xlab="Dimetro  altura do peito (cm)",ylab="Altura (m)",
	cex.axis=1.5,cex.lab=1.7,main="Eucalypthus saligna",cex.main=1.8,pch=16,col="red",cex=1.4)

png(filename = "saligna.png")

graphics.off()

######################5.2 Dois grficos juntos ############################

head(saligna)
table(saligna$talhao)

# Use as variveis dap e talhao para construir dois grficos, colocando-os lado
# a lado. O primeiro deve ser um grfico de desenho de caixa (boxplot) da varivel 
# dap em funo do fator talho. O segundo deve ter apenas a mdia e uma barra 
# de desvio-padro do dap, para cada talho.

# Mantenha o mesmo padro de formatao do exerccio anterior.

# Insira tambm uma letra para dizer qual  o grfico a e qual  o b 
#(tanto faz, quem  um e quem  outro).

mn.dap <- (round(tapply(saligna$dap,saligna$talhao,mean)))
sd.dap <- (round(tapply(saligna$dap,saligna$talhao,sd)))
som <- mn.dap+sd.dap
dim <- mn.dap-sd.dap

par(mfrow=c(1, 2),tcl=0.3,las=1,mar=c(5.1,4.4,4.0,2.1),bty="l")

boxplot(saligna$dap~saligna$talhao, xlab="Talho",ylab="Dimetro  altura do peito (cm)"
	,cex.axis=1.5,cex.lab=1.7,main="Eucalypthus saligna",cex.main=1.8,ylim=c(0,30))
mtext("A",line=-2,adj=0.05,cex=1.5)
#legend(0.05,31,legend="A",bty="n")

plot(mn.dap,type="n",ylim=c(0,30),cex.axis=1.5,cex.lab=1.7,main="Eucalypthus saligna",
	cex.main=1.8,pch=16,col="red",cex=1.4,ylab="Dimetro  altura do peito (cm)",
	xlab="Talho",xaxt = "n",xlim=c(0,6.6))
points(mn.dap,col="orange",pch=16,ylab="Dimetro  altura do peito (cm)")
segments(c(1,2,3,4,5,6),c(14,19,16,20,19),c(1,2,3,4,5,6),c(6,7,8,10,9,7))
axis(1,1:6,c("16","17","18","22","23","32"),cex.axis=1.5)
mtext("B",line=-2,adj=0.05,cex=1.5)
# Ou isso: legend(0.6,31,legend="B",bty="n")


############# 5.3 Adivinhando o cdigo #######################################

adv <- read.table("exercicio3.csv",sep=",", h=T)
head(adv)
length(adv)
nrow(adv)

par(mfrow=c(1, 2),tcl=0.3,mar=c(5.1,4.1,4.0,2.1),bty="l")

plot(adv$x1,adv$y1,xlim=c(0.52,2.2),ylim=c(0.0,3.2),pch=17,bty="l",xlab="",ylab="",xaxt="n",yaxt="n")
axis(2,cex=1,family="serif",mgp=c(0,0.5,0))
mtext("Euclidean distances",side=2, line=2,cex=1.4,family="serif")
axis(1,cex=1,family="serif")
mtext("Log(Patch size)(ha)",side=1,line=2,cex=1,family="serif")
abline(lm(adv$y1~adv$x1),lwd=2)
mtext("a",line=-2,adj=0.99,cex=1.5,family="serif")


boxplot(adv$x2~adv$y2,bty="l",xlab="",ylab="",ylim=c(0.0,3.2),outline=F,xaxt = "n",yaxt="n")
axis(1,1:6,cex.axis=0.9,c("Small","Medium\nEdge","Medium\nInterior","Large\nEdge","Large\nInferior",
	"Control"),mgp=c(0,1.5,0),tcl=0.3,family="serif")
axis(2,cex.axis=1.1,family="serif")
mtext("*",line=-2,adj=0.11,cex=1.5)
mtext("*",line=-2,adj=0.27,cex=1.5)
mtext("**",line=-2,adj=0.42,cex=1.5)
mtext("*",line=-2,adj=0.582,cex=1.5)
mtext("***",line=-2,adj=0.761,cex=1.5)
mtext("b",line=-2,adj=0.99,cex=1.5)



