
# 4.2 Cervejas
# Uma amostra de 30 estudantes foi indagada sobre seu tipo de cerveja preferida, 
# com o seguinte resultado

cervejas <-c("chope","lata","garrafa","chope","garrafa", "garrafa","lata","lata",
   "nenhuma","lata","garrafa","garrafa","garrafa","lata","lata","lata","garrafa",
   "lata","chope","nenhuma","garrafa","garrafa","garrafa","chope","garrafa","garrafa",
   "chope","garrafa","lata","lata")

# 1.Represente este resultado como um grfico de barras e um dotplot (funo dotchart).

table(cervejas)

par(mfrow = c(1, 2))

barplot(sort(table(cervejas)),ylab="Nmero de alunos",xlab="Tipo de cerveja")

dotchart(sort(table(cervejas)))

# 2.Qual tem maior razo dado/tinta?
 # Resp.: a maior razao tinta e do grafico produido pela funcao dotchart, pois o gasto
 # de tinta e muito menor e a informacao e a mesma, mas de uma forma um pouco menos usual.


# 4.3 Caixetais
# Neste exerccio, use o objeto caixeta, criado no tutorial Explorao de uma Varivel
# Categrica.

cax <- read.csv("caixeta.csv", header=TRUE, as.is=TRUE)
head(cax)

# Construa um histograma do dap dos fustes dos caixetais.

cax$dap <- cax$cap/pi

hist(cax$dap, xlab="DAP", ylab="Frequncia",main="Frequncia dos valores de DAP na 
   comunidade")


# Construa histogramas da altura das rvores para os diferentes caixetais ('local').

par(mfrow = c(1, 3))
hist( cax$h[ cax$local == "chauas" ] )
hist( cax$h[ cax$local == "jureia" ] )
hist( cax$h[ cax$local == "retiro" ] )


# H diferenas entre as estruturas (distribuio de tamanhos) dos caixetais?
 # Resp.: sim, em Chauas, a maior frquencia de alturas sen concentra entre 50 e 100
 # e tem alturas que chegam ao valor 500 (seja a unidade que for). Jureia parece term maior 
 # frequencia entre 50 e 125, com pouca variacao de alturas das arvores (altura
 # maxima de ~250). Em Retiro, a maior frequencia de altura ocorreu por volta de 50 e 
 # proximo a 100, e com altura maxima ~ 200.


# 4.4 Eucaliptos
# Neste exerccio, use o conjunto de dados Inventrio em Florestas Plantadas de 
# Eucalyptus grandis.

egr <- read.csv("egrandis.csv",header=T,sep=";")
head(egr)


# Utilize o grfico boxplot para analisar o DAP de rvores de E. grandis em funo 
# das variveis regio (regiao) e rotao (rotacao).

boxplot( dap ~ regiao*rotacao, data=egr, ylab="DAP", xlab="Regies e respectivas rotaes")

### CONFERIR ESSE!
# Avalie a normalidade da altura do conjunto total de rvores com um grfico 
# quantil-quantil contra a distribuio normal.

qqnorm(egr$ht)
qqline(egr$ht)

# Os valores empiricos parecem nao ter distribuicao normal, pois os pontos dos quantis
# extremos nao se sobrepoem a reta produzida com os valores teoricos esperados

# 4.5 Mais Caixetais
# Aqui usaremos novamente o objeto caixeta, criado no tutorial Explorao de 
# uma Varivel Categrica.

cax <- read.csv("caixeta.csv", header=TRUE, as.is=TRUE)
cax$dap <- cax$cap/pi

# Analise a relao dap-altura ('dap' e 'h') em funo do caixetal (local) com a funo
# plot, mas somente para as rvores de caixeta (Tabebuia cassinoides).
head(cax)

 #separando so a spp de interesse 
(sp <- unique(cax$especie))

ts <- cax[cax$especie == sp[3],]

 #calculo da area basal por fuste (+ de 1 fuste por arvore): 

head(ts)
ts$area.basal <- pi*(ts$dap)^2/4 
head(ts)

 # somar os fustes de cada arvores (so vai haver uma medida por individuo)

soma.fu <- aggregate(ts$area.basal, by = list(h=ts$h,local=ts$local,
	arvore=ts$arvore), sum)

colnames(soma.fu) <- c("h", "local", "arvore", "area")
head(soma.fu)

ts2 <- soma.fu

ts2$dap1 <- 2*(sqrt(soma.fu$area/pi))
head(ts2)

par(mfrow=c(1,3))
with(subset(ts2, local=="chauas"),plot(dap1~h,main="Chauas"))
with(subset(ts2, local=="retiro"),plot(dap1~h,main="Retiro"))
with(subset(ts2, local=="jureia"),plot(dap1~h,main="Juria"))


# Para a mesma relao do item anterior, verifique linearidade com a funo 
# scatter.smooth

par(mfrow=c(1,3))
with(subset(ts2, local=="chauas"),scatter.smooth(dap1~h,main="Chauas", lpars=list(col="blue")))
with(subset(ts2, local=="retiro"),scatter.smooth(dap1~h,main="Retiro", lpars=list(col="blue")))
with(subset(ts2, local=="jureia"),scatter.smooth(dap1~h,main="Juria", lpars=list(col="blue")))


# Utilizando o pacote lattice, analise a relao dap-altura ('dap' e 'h') em funo do 
# caixetal (local), mas somente para as rvores 3) de caixeta (Tabebuia cassinoides).

library(lattice)
(graf <- xyplot(dap1~h|local, data=ts2))
