library(MASS)
data(Animals)
str(Animals)
head(Animals)

anim.m2 <- lm(log(brain)~log(body),data=Animals, 
              subset=!(log(Animals$body)>8&log(Animals$brain)<6))

summary(anim.m2)
anova(anim.m2)
plot(log(brain)~log(body),data=Animals)

# Agora ajuste este modelo:

anim.m0 <- lm(log(brain)~1, data=Animals, 
              subset=!(log(Animals$body)>8&log(Animals$brain)<6))

summary(anim.m0)
anova(anim.m0)
plot(log(brain)~1,data=Animals)

# E compare os dois:

anova(anim.m0,anim.m2)

# 1. Qual a relao do comando "anova(anim.m0,anim.m2)" com:

anova(anim.m2)

	# Resp.: a anova(anim.m2), que esta aplicada apenas ao modelo de interesse,
	# apresenta a particao da variancia, onde obtemos os valores da soma dos quadrados,
	# que resulta no quanto a variavel independente (x) explicou a variavel dependente 
	#(y) e o quanto nao foi explicado, que sao os valores dos residuos ("Residuals"). 
	# No caso da anova(anim.m0,anim.m2)os resultados sao os mesmos, pois a comparacao 
	# foi entre o modelo de interesse
	#(o cerebro ("log(brain)") em funcao do corpo ("log(body)") e o modelo nulo 
	#(como se a variavel independente nao tivesse efeito sobre a variavel dependente).


# 2. Qual a relao entre os valores obtidos por estes comandos:

summary(anim.m0)
mean(log(Animals$brain[!(log(Animals$body)>8&log(Animals$brain)<6)]))
sd(log(Animals$brain[!(log(Animals$body)>8&log(Animals$brain)<6)]))

	# Resp.: a media e o desvio padrao sao medidas que estao inseridas no comando
	# summary, que sumariza os valores das analises mais comumente utilizadas para
	# interpretacao dos dados. Como o modelo que estamos solicitando as informacoes
	# e um modelo nulo (em que a preditora nao influencia a variavel resposta), os
	# valores da media e do desvio padrao sao equivalentes ao valor estimado do intercepto
	# e ao valor residual do erro padrao.

# Dica
# Um comando mais curto para ajustar o modelo deste exerccio, e que ajuda a interpret-lo:

anim.m0 <- update(anim.m2, .~. -log(body))
summary(anim.m0)