############################################################
#      Exercício 7.2  O modelo mais simples possível       #
############################################################

### Vamos retomar a regressão da massa do cérebro em função da massa corporal de alguns animais, do tutorial ajuste e diagnóstico de uma regressão:

library(MASS)
data(Animals)
str(Animals)

anim.m2 <- lm(log(brain)~log(body),data=Animals, subset=!(log(Animals$body)>8&log(Animals$brain)<6))
anim.m2

### Agora ajuste este modelo:
anim.m0 <- lm(log(brain)~1, data=Animals, subset=!(log(Animals$body)>8&log(Animals$brain)<6))
anim.m0

### E compare os dois:
anova(anim.m0,anim.m2)

##### Perguntas

#### 1. Qual a relação do comando 'anova' acima com:

anova(anim.m2)

# R: # Os comandos estão relacionados, pois os valores mais importantes para interpretar a anova aplicada ao segundo modelo são os mesmos (somas quadráticas e graus de liberdade tanto referentes aos resíduos quanto à variável preditora, F e P)
# Mas enquanto o primeiro comando está comparando dois modelos, buscando identificar qual dos dois explica melhor o comportamento do conjunto de dados, o segundo está apresentando a tabela completa de partição de variâncias apenas de um dos modelos. Essa tabela apresenta as médias das somas quadráticas, que a anterior não mostra, mas que ajudam a entender como chegamos ao F.
  
#### 2. Qual a relação entre os valores obtidos por estes comandos:

summary(anim.m0)
mean(log(Animals$brain[!(log(Animals$body)>8&log(Animals$brain)<6)]))
sd(log(Animals$brain[!(log(Animals$body)>8&log(Animals$brain)<6)]))

# R: A relação entre os comandos é de que o segundo e o terceiro estão contidos no primeiro. 
# O segundo comando calcula a média dos resíduos. O terceiro calcula o erro padrão dos resíduos. O primeiro apresenta o sumário da distribuição dos resíduos, que contém as informações da média ("Estimate") e do erro padrão (Residual standard error).

#### Dica
### Um comando mais curto para ajustar o modelo deste exercício, e que ajuda a interpretá-lo:
  anim.m0 <- update(anim.m2, .~. -log(body))
  
 
###

