############################################################
#      Exercício 7.b  Exercícios de regressão múltipla     #
############################################################

#### Uma estimativa da incerteza na previsão do modelo
### Antes de passarmos para os exercícios de regressões múltiplas, vamos revisar a regressão simples mais uma vez. Uma forma de avaliar a incerteza na previsão de um modelo de regressão é fazer um gráfico com o intervalo de confiança de 95% da previsão do modelo. Para isso é preciso estimar esse intervalo da previsão e plotar um gráfico com os dados, o modelo e as curvas do intervalo de confiança. Para estimar o intervalo de confiança é preciso calcular o erro padrão da previsão do modelo e multiplicar pelo valor t de Student, para n-2 graus de liberdade. O erro padrão não é constante para todos os valores previstos, pode variar de acordo com o valor da variável preditora de acordo com a fórmula.

#ANTES DE TUDO preciso corrigir o data frame

bebes <- read.table(file="babies.txt", header=TRUE, sep=" ")
#checando data.frame
bebes
head(bebes)
str(bebes)

# checando linhas com dados faltantes
which(bebes$height==99)
which(bebes$gestation==999)

# testando eliminação das observações com dados faltantes:
bebes$gestation[bebes$gestation==999] <- NA
bebes$height[bebes$height==99] <- NA

# retirando linhas com NA:
bebes <- bebes[complete.cases(bebes),]
bebes
# checando se reduziu número de linhas:
nrow(bebes)

# transformando dados faltantes para NAs em todas as linhas
bebes$bwt[bebes$bwt==999] <- NA
bebes$gestation[bebes$gestation==999] <- NA
bebes$parity[bebes$parity==9] <- NA
bebes$age[bebes$age==99] <- NA
bebes$height[bebes$height==99] <- NA
bebes$weight[bebes$weight==999] <- NA
bebes$smoke[bebes$smoke==9] <- NA

# retirando linhas com NA:
bebes <- bebes[complete.cases(bebes),]
bebes

# checando se reduziu número de linhas:
nrow(bebes)

# OK

### Construa esse gráfico para avaliar a incerteza do modelo para a relação peso do bebê (kg) ~ tempo de gestação (dias) dos dados Massa ao Nascer e Dados da mãe, usando a fórmula acima para estimar o intervalo de confiança de 95%.

#criando objetos para as variáveis do gráfico:
peso.b <- bebes$bwt
peso.b
gestacao <- bebes$gestation
gestacao

# gerando modelo e plotando reta da regressão linear
plot(peso.b~gestacao, data=bebes)
lm.gest <- lm(peso.b~gestacao, data=bebes)
summary(lm.gest)
abline(lm.gest, col="blue", lwd=2)

#criando um vetor para representar a variável preditora como uma sequência de 100 valores compreendidos entre os valores máximo e mínimo da variável preditora observada

#eixo x do IC
newx <- seq(min(gestacao)-10, max(gestacao)+10, length.out=100)
newx

#eixo y do IC
predicoes <- predict(lm.gest, newdata=data.frame(gestacao=newx),interval='confidence')
predicoes

# PLOTANDO o intervalo de confiança

polygon(c(rev(newx),newx),c(rev(predicoes[,3]),predicoes[,2]),col=rgb(0,0,0,0.25), border=NA)

# Fórmula do erro padrão:

var.b <- var(peso.b)
var.b

ssx.m <- ((newx-mean(gestacao))^2)/(sum((gestacao-mean(gestacao))^2))
ssx.m

se2 <- sqrt(var.b*((1/length(gestacao))+ssx.m))

t <- qt(0.025, length(gestacao)-2, lower.tail = FALSE) 
t

ic <- t*se2
ic


#####Galileu estava Certo?

### Partindo do tutorial Ajuste de Polinômios, avalie se um polinômio de terceiro grau é um melhor modelo para descrever os dados do experimento de Galileu. A equação para este modelo é:

# As alturas de lançamentos e as distâncias percorridas obtidas por Galileu são:

init.h = c(600, 700, 800, 950, 1100, 1300, 1500)
h.d = c(253, 337, 395, 451, 495, 534, 573)

# gráfico de dispersão:

plot(h.d~init.h)

#gerando modelo linear simples:

mod1 <- lm(h.d~init.h)
plot(mod1)  # Inspecionando os gráficos de diagnóstico

#ajustando modelo de segundo grau, com parábola:

mod2 <- update(mod1,.~. +I(init.h^2))

#comparando os dois modelos:

anova(mod1,mod2)

# O modelo de parábola é superior:

abline(mod1)
cf.m2 <- coef(mod2)
curve(cf.m2[1]+cf.m2[2]*x+cf.m2[3]*x^2, add=T, lty=2)

#verificando o resumo do modelo selecionado:

summary(mod2)

# VERIFICANDO AJUSTE AO POLINÔMIO DE TERCEIRO GRAU

#criando modelo 3, de terceiro grau:

mod3 <- update(mod2,.~. +I(init.h^3))

# comparando os dois modelos:

anova(mod2,mod3)

# O modelo de terceiro grau é superior
# Plotando no gráfico:

cf.m3 <- coef(mod3)
curve(cf.m3[1]+cf.m3[2]*x+cf.m3[3]*x^2+cf.m3[4]*x^3, add=T, lty=2, col="blue")

#verificando o resumo do modelo de terceiro grau:

summary(mod3)

# RESPOSTA: SIM, O polinômio de terceiro grau é um melhor modelo para descrever os dados do experimento de Galileu






##### Massa de Recém-Nascidos
### Utilize todas as variáveis disponíveis no conjunto de dados Massa ao Nascer e Dados da mãe para chegar ao melhor modelo de previsão da massa de bebês ao nascer.
# testando modelo cheio:
lm.full<-lm(bwt~gestation*parity*age*height*weight*smoke, data = bebes)
lm.full
anova(lm.full)
# SIMPLIFICANDO DRASTICAMENTE: selecionando modelo com as variáveis preditoras que deram Pr<0,05: gestation + parity + heigth + weigth + smoke + gestation:age + gestation:weigth + gestation:smoke

lm.1 <- lm(bwt~gestation + parity + height + weight + smoke + gestation:age + gestation:weight + gestation:smoke, data=bebes)
anova(lm.1)

# testando mais simplificações:
lm.2.1 <- lm(bwt~gestation + parity + height + weight + smoke + gestation:age + gestation:weight, data=bebes)
anova(lm.1, lm.2.1)
lm.2.2 <-lm(bwt~gestation + parity + height + weight + smoke + gestation:age + gestation:smoke, data=bebes)
anova(lm.1, lm.2.2)
lm.2.3 <-lm(bwt~gestation + parity + height + weight + smoke + gestation:weight + gestation:smoke, data=bebes)
anova(lm.2.3, lm.1)

# Os modelos 2.2 e 2.3, que retiram respectivamente as interações gestation:age e gestation:weight, não tem diferença significativa para o modelo 1, portanto podemos retirar as duas para ficar com o modelo MÍNIMO ADEQUADO (lm.3), que tem apenas gestation:smoke como interação, facilitando a interpretação dos dados:

lm.3 <- lm(bwt~gestation + parity + height + weight + smoke + gestation:smoke, data=bebes)
# checando que de fato lm.1 e lm.3 são semelhantes, então ficamos com lm.3, que é mais simples:
anova(lm.1, lm.3)
anova(lm.3)

########lm.3 é o MODELO MÍNIMO ADEQUADO, portanto o MELHOR MODELO#######





#####EXTRA#####

# exercitando a interação de variáveis prevista manualmente (apenas até interações de três fatores). OBS: ficaria bastante complexo, sem o sinal de *, gerar o modelo cheio, com tantas variáveis:
lm.manual <-lm(bwt~gestation + parity+ age + height + weight + smoke + 
gestation:parity + gestation:age + gestation:height + gestation:weight + gestation:smoke + parity:age + parity:height + parity:weight + parity:smoke + age:height + age:weight + age:smoke + height:weight + height:smoke + weight:smoke + gestation:parity:age + gestation:height + gestation:weight + gestation:smoke + parity:age + parity:height + parity:weight + parity:smoke + age:height + age:weight + age:smoke + height:weight + height:smoke + weight:smoke +
gestation:parity:age + gestation:parity:height + gestation:parity:weight + gestation:parity:smoke + gestation:age:height + gestation:age:weight + gestation:age:smoke + gestation:height:weight + gestation:height:smoke + gestation:weight:smoke + parity:age:height + parity:age:weight + parity:age:smoke + age:height:weight + age:height:smoke + height:weight:smoke
data = bebes) 