############################################################
#      Exercícios 8. Reamostragem e Simulação              #
############################################################

#######################
##### Exercício 1.#####
#######################
#### Os palmitos estão distribuídos aleatoriamente na floresta? Durante a aula teórica mostramos como podemos usar uma distribuição teórica para gerar dados que simulem o cenário previsto por nossa hipótese nula. No caso da posição dos palmitos adultos em uma parcela de 10,24 ha de floresta (320×320 m), nossa hipótese nula é que eles se distribuem aleatoriamente no espaço. Iniciamos a construção do código para testar essa hipótese, o exercício é terminar de testar a hipótese. Abaixo reproduzimos o código apresentado em aula para que possa continuar a partir dele.
###  1.1. Baixe o arquivo palmadulto.txt e leia os dados no R em um objeto chamado eutad, não esqueça de conferir se o objeto de dados foi lido corretamente.

eutad <- read.table("palmadulto.txt", header=TRUE)
eutad 
###  1.2. Crie o objeto para guardar as distâncias entre cada indivíduo: 
dist=matrix(NA, ncol=102, nrow=102)

### 1.3. Calcule a distãncia observada entre cada indivíduo e guarde o resultados em dist:

for(i in 1:101)
    {
        for(j in (i+1):102)
            {
                difx2=(eutad$gx[i]-eutad$gx[j])^2
                dify2=(eutad$gy[i]-eutad$gy[j])^2
                dist[i,j]<-sqrt(difx2 + dify2)
                dist[j,i]<-sqrt(difx2 + dify2)
            }
          
    }

### 1.4. Verifique o objeto dist e calcule o parâmetro chamado de distância média do vizinho mais próximo (MNN):

str(dist)
(nn<-apply(dist,1,min,na.rm=TRUE))
(mnn<-mean(nn))
mnn

#### Simulando
### Até agora calculamos o valor esperado da distância média do vizinho mais próximo. Os próximos passos, são:

### 1.5. Crie um vetor resultado, com 1000 NA's, para guardar os valores de cada simulação.

resultado <- rep(NA,1000)
str(resultado)

### 1.6. Guarde o valor observado na primeira posição de resultado;

resultado[1] <- mnn
head(resultado)

### 1.7. Crie um ciclo com contador (k) que vai de 2 a 1000;

### 1.8. Dentro do ciclo:
	## 1.8.1. Crie o objetos xsim, um vetor com valores amostrados aleatoriamente de uma distribuição uniforme de 0 a 320 (o tamanho x da parcela), arredondando o valor para uma casa decimal. Lembre-se de sortear o mesmo quantidade de valores que a população de palmito observado; 
	## 1.8.2. Faça o mesmo que no passo anterior e guarde no objeto ysim;
	
	## 1.8.3. Como no tópico anterior, crie uma matriz para guardar as distâncias entre cada valor xy simulados;
	
	## 1.8.3. Crie os ciclos para o calculo das distâncias como no tópico anterior; 
	## 1.8.4. Guarde o valor da distância média do vizinho mais próximo dos dados simulados na posição k do vetor resultado; 
	## 1.8.5. Feche o ciclo.
	
for (k in 2:1000)
{
	xsim <- round(runif(102,min=0,max=320),1)
	ysim <- round(runif(102,min=0,max=320),1)
	dist.sim <- matrix(NA, ncol=102, nrow=102)
	
	for(i in 1:101)
    {
        for(j in (i+1):102)
            {
                difx2=(xsim[i]-xsim[j])^2
                dify2=(ysim[i]-ysim[j])^2
                dist.sim[i,j]<-sqrt(difx2 + dify2)
                dist.sim[j,i]<-sqrt(difx2 + dify2)
            }
          
    }
	
	(nn.sim<-apply(dist.sim,1,min,na.rm=TRUE))
	(mnn.sim<-mean(nn.sim))
	resultado[k] <- mnn.sim
	
}

resultado
class(resultado) 
### 1.9. Faça um histograma dos valores simulados e coloque uma linha vermelha vertical na posição do valor observado;

hist(resultado)
abline(v=mnn,col="red")
mnn

### 1.10. Calcule a probabilidade de uma distribuição espacial aleatória gerar valores iguais ou mais extremos do que o valor MNN observado.

#calculando o denominador do p:
length(resultado)
#calculando a media dos mnn simulados: 
media.sim<-mean(resultado)
#calculando a distância da media para o valor observado:
dist.media.mnn<-mnn-media.sim
#calculando limite do upper tail
upper.tail<-media.sim+(abs(dist.media.mnn))
upper.tail

sum(resultado<=mnn | resultado>=upper.tail)
p <- sum(resultado<=mnn | resultado>=upper.tail)/length(resultado)
p

# R:
# O valor de p calculado pela equação foi de 0.05.
# No entanto, podemos representar esta probabilidade como:
# p<0.05
# Isso significa que a probabilidade de uma distribuição espacial aleatória gerar valores iguais ou mais extremos do que o valor MNN observado é menor que 5%, já que em 1000 simulações de cenário nulo, 49 geraram um valor mais extrema que o valor MNN observado, que somados ao MNN observado resultaram no p de 50/1000=0.05


#######################
##### Exercício 2.#####
#######################

##### Simulando o teste de uma regressão linear
#### O principal teste estatístico de uma regressão linear é que a inclinação do modelo da reta é diferente de zero! Isso significa que a variável preditora é independente da variável reposta. Ou seja não há relação aparente entre elas. Utilizando os dados de massa corpórea e do cérebro de alguns vertebrados Conjunto de Dados: Massa do Corpo e do Cérebro de Vertebrados:

animais <- read.table("animais.txt", sep=";", dec = ",", header=TRUE)
animais
#checando data frame
str(animais)
#removendo observações com NA
animais <- na.omit(animais)
animais
str(animais)

###2.1. Calcule a inclinação da relação log(brain) ~ log(body);

# calculando a regressão linear, por meio da função lm, e atribuindo ao objeto lm.1
lm.1 <- lm(log(brain)~log(body), data=animais)
# extraindo os coeficientes (intercepto e inclinação) do objeto lm.1
coef(lm.1)
# indexando a posição do vetor dos coeficientes que contém a inclinação:
inclinacao.1 <- coef(lm.1)[2]
# checando a inclinação
inclinacao.1

###2.2. Crie um vetor para guardar o resultado de simulações;

resultado <- rep(NA,1000)
str(resultado)

###2.3. Guarde o valor observado no objeto criado em 2.2;

resultado[1] <- inclinacao.1
str(resultado)

###2.4. Abra um ciclo de 2 a 1000;
###2.5. Desordene o vetor brain e guarde no objeto sim_brain;
###2.6. Calcule a inclinação entre o log(sim_brain) ~ log(body) e guarde no vetor resultado;
###2.6. Calcule a inclinação entre o log(sim_brain) ~ log(body) e guarde no vetor resultado;
###2.7. Feche o ciclo;

for (i in 2:1000)
{
	sim_brain <- sample(animais$brain)
	resultado[i] <- coef(lm(log(sim_brain)~log(animais$body)))[2]	
}

# checando vetor com resultado
str(resultado)

###2.8. Faça o histograma dos valores simulados e compare com o valor observado da inclinação da relação;

hist(resultado)
abline(v=resultado[1], col="red", lty=2)

###2.9. Calcule a probabilidade da inclinação observada ter sido gerada por variáveis que são independentes;

p <- sum(resultado>=resultado[1] | resultado <= -resultado[1])/length(resultado)
p

# R:
# O valor de p calculado pela equação foi de 0.001.
# No entanto, podemos representar esta probabilidade como:
# p<0.001
# Isso significa que a probabilidade da inclinação observada ter sido gerada por variáveis que são independentes é menor que 0,1%, já que em 1000 simulações de cenário nulo nenhuma gerou uma inclinação mais extrema que a inclinação observada, uma vez que o único valor registrado no histograma foi o valor observado para a inclinação (razão do p calculado ser 0.001, e não 0)
