###################################################################
# Exercício 9.2 Análise exploratória simultânea de duas variáveis #
###################################################################

##### Tarefa: Crie uma função para saída gráfica de análises exploratórias de duas variáveis. Essa saída pode ter por exemplo boxplot, histograma, qq norm e y por x. A função deve permitir a entrada de dois objetos vetores de mesmo tamanho (x e y). Caso os valores de x e y forem desenhados em um mesmo gráfico, defina cores diferentes. As legendas devem ser em português e a saída (return) deve apresentar o sumário das duas variáveis e o coeficiente de correlação.

#criando função para saída gráfica
eda.xy <- function(x,y)
	{
		if(length(x)!=length(y)) #premissa dos vetores terem mesmo tamanho
			{
				stop("os vetores x e y não possuem o mesmo tamanho")
			}
		
		par(mfrow = c(1,2))
		plot(x,y,xlab="x",ylab="y", main="y em função de x",col="blue",pch=18,las=1)
		boxplot(x,y, main="BoxPlot de x e y",col=terrain.colors(4),names=c("x","y"),las=1)
		legend("topright", inset=.02, title="variáveis", c("x","y"), fill=terrain.colors(4), horiz=TRUE, cex=0.7)
		par(mfrow=c(1,1))
	
	return(list(paste("sumário da variável x:"),summary(x),paste("sumário da variável y:"),summary(y),paste("coeficiente de correlação entre x e y:"),cor(x,y,"complete.obs")))
	}

# testando a função:
x <- as.numeric(dados.pois20)
y <- dados.norm20
x <- sort(x)
y <- sort(y)
x
y

eda.xy(x,y)

#FUNCIONA!#



########################################################################
########################################################################
########################################################################
# 	Acrescento, abaixo, para avaliação, o código do exercício 109.3,   #
#   cujo item II roda no R mas não roda no NotaR 	   				   #
########################################################################
########################################################################
########################################################################
########################################################################
# 	NotaR_109.3 Índice de diversidade de espécies.R 	       #############
########################################################################

#####	I.	Construa uma função chamada "shannon" para computar o índice de diversidade de Shannon e outra função chamada "simpson" para o índice de diversidade de Simpson de uma amostra. Considere que:

###1. o objeto de entrada será um vetor contendo a abundância de cada espécie na amostra

###2. existe a possibilidade de haver dados faltantes nesse vetor ("NA"), os quais serão removidos para o cálculo dos índices.

##### Lembre-se: Não existe logaritmo de zero! Isso pode ser relevante para o cálculo do índice de Shannon!

shannon <- function(x)
	{
			x[x==0] <- NA
			z = (na.omit(x))
			n.NA=length(x)-length(z)
			cat("\t", n.NA, "valores NA excluídos \n")
				
			N <- sum(z)
			ni <- c(z)
			pi <- ni/N
			ln.pi <- log(pi)
			H <- -sum(pi*ln.pi)
			
			cat("\n", "Índice de diversidade de Shannon", "\n")
			return(H)			
					
	}

# testando Shannon
teste <- c(0,1,4,10)
shannon(teste)


simpson <- function(x,)
	{				
			x[x==0] <- NA
			z = (na.omit(x))
			n.NA=length(x)-length(z)
			cat("\t", n.NA, "valores NA excluídos \n")
					
			N <- sum(z)
			ni <- c(z)
			pi <- ni/N
			pi.2 <- pi^2
			D <- sum(pi.2)
			
			cat("\n", "Índice de diversidade de Simpson", "\n")
			return(D)			
					
	}

# testando Simpson
teste <- c(0,1,4,10)
simpson(teste)

######################################################################################

##### II. Agora considere que você coletou varias amostras de abundância das espécies em diversas comunidades e organizou esses dados em uma matriz, na qual as linhas representam espécies e as colunas representam diferentes amostras. Construa uma função chamada " diversidade", que retorna um vetor contendo um dos dois índices de diversidade (a ser escolhido pelo usuário), calculado para cada amostra.Lembre-se que:

###	◦	Esta função deverá possuir dois argumentos: o primeiro deve representar os dados, e o segundo deve ser um parâmetro relacionado à escolha do usuário (e.g. indice), que poderá receber os valores "shannon" ou "simpson".
###	◦	O objeto de entrada na função "diversidade" deverá ser uma matriz com a abundância das espécies nas linhas e amostras nas colunas.


diversidade <- function(matriz,indice)
	{
		resulta <- rep(NA,ncol(matriz))
		
		for(i in 1:ncol(matriz))
			{
				if(indice=="shannon")
					{
						amostra <- matriz[,i] 
						amostra[amostra==0] <- NA
						z = (na.omit(amostra))
				
						N <- sum(z)
						ni <- c(z)
						pi <- ni/N
						ln.pi <- log(pi)
						H <- -sum(pi*ln.pi)
			
						resulta[i] <- H
					}
				
				if(indice=="simpson")
					{
						amostra <- matriz[,i] 
						amostra[amostra==0] <- NA
						z = (na.omit(amostra))
						
						N <- sum(z)
						ni <- c(z)
						pi <- ni/N
						pi.2 <- pi^2
						D <- sum(pi.2)
						
						resulta[i] <- D
					}
				
			}

			if(indice=="shannon")
				{
					cat("\n", "Índices de diversidade de Shannon, por amostra", "\n")
				}
			if(indice=="simpson")
				{
					cat("\n", "Índices de diversidade de Simpson, por amostra", "\n")
				}
			
			return(resulta)
	}

# testando função
mat.teste.1 <- matrix(rep(seq(0,14),2),ncol=6,nrow=5)
diversidade(mat.teste.1,indice="shannon")
diversidade(mat.teste.1,indice="simpson")

########FUNCIONA!##########