# Exercicio 7b. Regresso Mltipla #

# Uma estimativa da incerteza na previsao do modelo#

babies <- read.table("babies.txt", header = T, sep = " ", dec = ".")
babies <- babies[babies$gestation!=999,]
mod.babies <- lm(bwt~gestation, data=babies)
summary(mod.babies)

var <- var(babies$bwt)
n <- length(babies$bwt)
media <- mean(babies$gestation)
desv <- sum((babies$gestation-media)^2)
vetor <- seq(min(babies$gestation),max(babies$gestation), 2)
erro <- sqrt(var*((1/n)+(((vetor-media)^2)/desv)))
valor <- qt(0.025,98)
cont <- erro*valor

predito <- mod.babies$coefficients[1]+(mod.babies$coefficients[2]*vetor)
plot(bwt~gestation, data=babies, xlim=c(150,350))
abline(mod.babies, col="red")
lines(vetor,predito+cont, col="red", lty=2)
lines(vetor,predito-cont, col="red", lty=2)

# Galileu estava certo?#

init.h = c(600, 700, 800, 950, 1100, 1300, 1500)
h.d = c(253, 337, 395, 451, 495, 534, 573)
plot(h.d~init.h)
mod1 <- lm(h.d~init.h)
mod2 <- update(mod1,.~. +I(init.h^2))
mod3 <- update(mod2,.~. +I(init.h^3))
abline(mod1)
cf.m2 <- coef(mod2)
curve(cf.m2[1]+cf.m2[2]*x+cf.m2[3]*x^2, add=T, lty=2, col="red")
cf.m3 <- coef(mod3)
curve(cf.m3[1]+cf.m3[2]*x+cf.m3[3]*x^2+cf.m3[4]*x^3, add=T, lty=2, col="green")
summary(mod1)
summary(mod2)
summary(mod3)
anova(mod1,mod2)
anova(mod1,mod2)
anova(mod2,mod3)

# O modelo 3 (polinomio de terceiro grau) parece ser um melhor modelo, ja que apresenta maior R quadrado,  significativamente diferente dos outros modelos e tambm o modelo que mais explica os dados.#


# Massa de Recem-Nascidos#

babies <- read.table("babies.txt", header = T, sep = " ", dec = ".")
babies <- babies[babies$gestation!=999&babies$age!=99&babies$height!=99&babies$weight!=999&babies$smoke!=9,]
m.babies.full <- lm(bwt~gestation*parity*age*height*weight*smoke, data=babies)
summary(m.babies.full)
plot(bwt~gestation*parity*age*height*weight*smoke, data=babies)

mod1.babies <- lm(bwt~gestation, data=babies)
mod2.babies <- lm(bwt~parity, data=babies)
mod3.babies <- lm(bwt~age, data=babies)
mod4.babies <- lm(bwt~height, data=babies)
mod5.babies <- lm(bwt~weight, data=babies)
mod6.babies <- lm(bwt~smoke, data=babies)
mod7.babies <- lm(bwt~gestation*height*weight*smoke, data=babies)
mod8.babies <- lm(bwt~gestation*height*weight*smoke*age, data=babies)
mod9.babies <- lm(bwt~gestation*height*weight*smoke*parity, data=babies)
mod10.babies <- lm(bwt~gestation*smoke+parity+height, data=babies)

summary(mod10.babies)
anova(m.babies.full,mod10.babies)
# O modelo mod10.babies,que contem as preditoras gestation, smoke, parity, height e a interacao entre gestation e smoke  o modelo mais simples para determinar o peso dos bebes em relacao ao modelo completo, com todas as variaveis.#
