saligna<- dados.esaligna<- read.table("esaligna.csv", header = T, sep = ",", dec = ",", as.is = TRUE)
str(saligna)
par(cex.lab= 1.5, tcl=0.3)
plot(saligna$ht~saligna$dap, cex=1.4,type="p", col="red", pch=19,xlab= "", ylab= "", las=1, bty="l")
mtext("*Eucalypthus saligna*", side= 3, cex=1.8)
mtext("Dimetro  altura do peito(cm)", side=1, cex=1.5, line=2.5)
mtext("Altura (m)", side=2, cex=1.7, line=2.5)
savePlot("saligna.png", type="png")

saligna$dap<- as.numeric(saligna$dap)
media.saligna<- mean(saligna$dap)
dp.saligna<- sd(saligna$dap)

table(saligna$dap, saligna$talhao)
dap.talhao<- aggregate(saligna$dap, by= list (saligna$talhao), FUN=mean)
dp.talhao<- aggregate(saligna$dap, by= list (saligna$talhao), FUN=sd)

plot(dap.talhao)
dp.talhao$Group.1 

sd.sup<-dap.talhao$x + dp.talhao$x
sd.inf<-dap.talhao$x - dp.talhao$x

par(mfrow=c(1,2),tcl=0.3)
boxplot(saligna$dap ~ saligna$talhao, ylim=c(5,25), ylab= " ", xlab= " ", las=1)
mtext("*Eucalypthus saligna*", side= 3, cex=1.2, line=-2)
mtext("Dimetro  altura do peito(cm)", side=2, cex=1.5, line=2.5)
mtext("Talho", side=1, cex=1.5, line=2.5)
text("a", x= 10.55803, y= 24.87460, cex=1.5)
par(tcl=0.3)
plot(dap.talhao, ylim= c(5,25), ylab= " ", xlab= " ", las=1,cex=1.4)
mtext("*Eucalypthus saligna*", side= 3, cex=1.2, line=-2)
mtext("Dimetro  altura do peito(cm)", side=2, cex=1.5, line=2.5)
text("b", x=31.76123,y= 25.01149, cex=1.5)
mtext("Talho", side=1, cex=1.5, line=2.5)
arrows(x0=16,x1=16, y0=6.6, y1= 14.1)
arrows(x=17 , x1=17, ,y=6.961754, y1=19.00967)
arrows(x0=18 ,x1=18 , y0= 7.366797, y1=15.89987)
arrows(x0=22 ,x1=22 , y0= 9.896206, y1=20.86379)
arrows(x0=23 ,x1=23 , y0=8.433185, y1=18.74182 )
arrows(x0= 32,x1=32 , y0=6.864501 , y1=19.43550)
savePlot("Graficos_junto", type="png")

exercicio3<- read.table("exercicio3.csv" , header = T, sep = ",", dec = ",", as.is = TRUE)
exercicio3$x1<- as.numeric(exercicio3$x1)
exercicio3$x2<- as.numeric(exercicio3$x2)
exercicio3$y1<- as.numeric(exercicio3$y1)

str(exercicio3)
exercicio3[1:6,4]<- "small"
exercicio3[7:10,4]<- "Medium Edge"
exercicio3[11:18,4]<- "Medium Interior"
exercicio3[19:22,4]<- "Large Edge"
exercicio3[23:27,4]<- "Large Interior"
exercicio3[28:31,4]<- "Control"

exercicio3$y2<- ordered(exercicio3$y2, levels=c("small", "Medium Edge","Medium Interior","Large Edge","Large Interior","Control"))    	

table(exercicio3$x1, exercicio3$y2)

par(mfrow=c(1,2),tcl=0.3)
plot(exercicio3$x2~exercicio3$x1,na.rm=TRUE, ylim= c(0,3), bty="l",xlab=" ", ylab=" ", pch=17)
text("a", x=2.341010 , y=2.844296, cex=1.5,family="serif" )
mtext("Log(Patch size)(ha)", side=1, cex= 1.5, family="serif", line=2.5)
mtext("Euclidean distances", side=2, cex= 1.5, family="serif", line=2.5)
abline(lm(exercicio3$x2~exercicio3$x1))
boxplot(exercicio3$y1~exercicio3$y2, xlab=" ", ylab=" ", ylim=c(0,3))
text("*", x=0.9985886, y=2.875134) 
text("*", x=1.9752536 , y=2.826532) 
text("**", x=2.9289382, y=2.826532)
text("*", x=3.9745443 , y=2.841113)
text("***", x=4.9512093 , y=2.821672) 
text("b", x=6.3645010, y= 2.797372, cex=1.5, family="serif")
savePlot("Adivinhando_Codigo", type="png")

save.image("Exercicio5_Graficos.RData")

