########## Exerccios 3 - Leitura e Manipulao de Dados ########

#### 3.0 Indexao de vetores

sq1<- seq(0,100,length.out=15)
sq2<- sq1[c(1,2,3,4,6,7,8,9,11,12,13,14,15)]
sq3<- sq1[c(1,3,5,7,9,11,13,15)]
bolo <- sq1
bolo[c(2,4,6,8,10,12,14)]<- c(2,4,6,8,10,12,14)
sq4<- bolo

#### 3.1 Distncia entre cidades

dist.cid <- matrix(NA, nrow=4, ncol=4)
rownames(dist.cid)<- c("Atenas", "Madri", "Paris", "Estocolmo")
colnames(dist.cid)<-  c("Atenas", "Madri", "Paris", "Estocolmo")
diag(dist.cid) <- 0
lower.tri(dist.cid)
dist.cid[lower.tri(dist.cid)]<- c(3949,3000,3927,1273,3188,1827)
upper.tri(dist.cid)
dist.cid[upper.tri(dist.cid)]<- c(3949,3000,1273,3927,3188,1827)
dist.cid
# A diferena desta matriz com a do exemplo do banco "Eurodist",  que esta  do tipo espelhada. 


#### 3.2 Criao de um data frame

cor<-as.factor(cor<- rep(rep(c("claro", "escuro"), each=3), 3))
dieta<-as.factor(dieta<-rep(c("A","B", "C"), each=6))
pesos <- c(0.1 , 1.1 , 3.7,1.5, -0.1, 2.0, 5.7, -1.2, -1.5, 0.6, -3.0, -0.3,3.0, -0.4, 0.6,-0.2, 0.3, 1.5)
hamsters<-data.frame(dieta, cor, pesos)
media<- mean(hamsters[,3])
#a funo tapply() permite gerar um subconjunto de dados a partir de uma determinada varivel (ex. media de pesos por cor) 
media.por.cor<- tapply(hamsters$pesos, hamsters$cor, mean)
media.por.dieta<- tapply(hamsters$pesos, hamsters$dieta, mean)
media.cruzada<- mean(hamsters[1:3,3])
# utilizando o argumento list()  possivel obter as medias cruzadas (ex. media de pesos por cor e dieta)
media.cruzada<-tapply(pesos, list(cor, dieta), mean)

### 3.3 Criando uma Matriz

matriz.normal <- matrix(rnorm (15, 10, sd=(sqrt(3.6))), 3, 5)
rownames(matriz.normal)<- paste(rep("L",3), (1:3),sep="")
colnames(matriz.normal) <- paste(rep("C",5), (1:5),sep="")                      
media<-apply(matriz.normal, 1, mean)                            
var<-apply(matriz.normal, 1, var)
linha<-data.frame(media,var) 
media<-apply(matriz.normal, 2, mean)
var<-apply(matriz.normal, 2, var)
coluna<-data.frame(media,var)


#### 3.4 Lendo e Salvando seus dados

e.grandis <- read.table(file ="egrandis.csv", head= T, sep=";", as.is=F)
#Ao importar um arquivo texto, a funo read.table transforma por default em fatores todas as variveis que tenham caracteres.
#Voc pode indicar quais dessas variveis no so fatores com o argumento as.is.
breviarium<-summary(e.grandis)
# ...[,9]) permite indexar um objeto, de modo a selecinar a varivel (coluna), 
#ou o individuo (linha)
cont.1<- table(e.grandis[,9])    
summary(cont.1)
cont.2<- table(e.grandis[,2], e.grandis [,3])
#o comando abaixo == "Bofete",] permite selecionar a dimenso 2 (colunas) 
bofete<- e.grandis[e.grandis[ ,3] == "Bofete",] 
# write.table () permite exporta um conjunto de dados de uma objeto.
write.table(bofete, file="bofete.txt", sep="\t" , row.names = F)
save.image("exercicios notaR.RData")
# save () permite listar varios objetos e criar um .Rdata
save(cont.1, cont.2, file = "Teste.RData")

### 3.5 Classes de objetos

# O objeto iris  um data.frame, equanto o objeto iris3  um array
iris<-iris
iris3<- iris3
#a funo aggregate() permite gera subconjuto de dados em funo de um atributo(ex. por espcie)
# "na.rm=TRUE" permite excluir os dados NA (not available)
mean.iris<-aggregate(iris, by= list (iris$Species), mean, na.rm=TRUE)
# apply() possibilita calcular a mdia das linhas (1) e/ou colunas (2) em arrays, basta especificar MARGIN 1 ou 2.
# o segundo argumento representa a diminsao do objeto, neste caso especifico seria 2= variaveis e 3= a espcie 
colnames(iris3)<-c("comprimento_sepala", "largura_sepala", "comprimento_petala", "largura_petala")
mean.iris3<- apply(iris3, c(2,3), FUN=mean)                   
save.image("Manipulao_Dados.RData")
getwd()
dir()


#### 3.6 Acrescentando Dados de Sntese

# cabecalho definitivo para leitura de dados "as.is=True" carrega a panilha como realmete ,
#isto , mantem os fatores!!!!
dados.esaligna<- read.table("esaligna.csv", header = T, sep = ",", dec = ",", as.is = TRUE)
str(dados.esaligna)
head(dados.esaligna)
summary(dados.esaligna)
# somente  possivel fazer calculos de mdias a partir de vetores numricos

dados.esaligna$tronco<- as.numeric(dados.esaligna$tronco)
dados.esaligna$folha <- as.numeric(dados.esaligna$folha)
#para conseguir calcular a soma das linhas colocar dimensa 1 "dados.esaligna[,c(6,8), ] ,1, sum)
dados.esaligna[,10] <- apply(dados.esaligna[,c(6,8), ] ,1, sum)
# para nomear a coluna, primeiro deve-se criar os valores das linhas
colnames(dados.esaligna) [10] <- "biomassa"
dados.esaligna2 <- dados.esaligna
dados.esaligna.fin <- dados.esaligna2
dados.esaligna.fin$dap <- as.numeric(dados.esaligna.fin$dap)
dados.esaligna.fin[,11]<- ((pi* dados.esaligna.fin$dap^2)/4)
colnames(dados.esaligna.fin)[11]<- "area.basal"
dados.esaligna.10cm <- dados.esaligna.fin[dados.esaligna.fin$dap > 10,]
dados.esaligna$dap<-as.numeric(dados.esaligna$dap)
area.basal<-  tapply(dados.esaligna.10cm$area.basal, INDEX = dados.esaligna.10cm$talhao, FUN=sum)
media.area.basal<- tapply(dados.esaligna.10cm$area.basal, INDEX = dados.esaligna.10cm$talhao, FUN=mean)

write.table(dados.esaligna, file="dados.esaligna.txt", sep="\t" , row.names = F)
write.table(dados.esaligna2, file="dados.esaligna.2.txt", sep="\t" , row.names = F)
write.table(dados.esaligna.fin, file="dados.esaligna.fin.2.txt", sep="\t" , row.names = F)
write.table(dados.esaligna.10cm, file="dados.esaligna.10cm.txt", sep="\t" , row.names = F)
write.table(dados.esaligna.fin, file="dados.esaligna.fin.txt", sep="\t" , row.names = F)
write.table(area.basal, file="area.basal.txt", sep="\t" , row.names = F)
write.table(media.area.basal, file="media.area.basal.txt", sep="\t" , row.names = F)





